#!/usr/bin/python

from __future__ import print_function
from __future__ import unicode_literals
import sys
import json
import os
import re
import time
import argparse
import traceback

import ssl

import cloudscraper

import wget
import requests, lxml.html

import getpass
import youtube_dl

from bs4 import BeautifulSoup


class DL:
    global s, _cookie
    s = requests.session()

    ep = None

    def __init__(self):
        self._cookie = None
        self.parentFolder = os.getcwd()
        self.main()

    def login(self, **kwargs):

        if (kwargs):
            self.course_url = str(kwargs['course_url']).strip()
            self.email = kwargs['email']
            self.password = kwargs['password']

        else:
            try:

                self.course_url = raw_input("Enter course url : ").strip()
                self.email = raw_input("Email : ")
                prompt_txt = "Password :"
                self.password = getpass.getpass(prompt=prompt_txt, stream=sys.stderr)

            except TypeError as e:
                prompt_txt = "Password :"
                prompt_txt = prompt_txt.encode("utf-8")
                self.password = getpass.getpass(prompt=prompt_txt, stream=sys.stderr)


            except Exception as e:
                self.course_url = input("Enter course url : ").strip()
                self.email = input("Email : ")
                self.password = getpass.getpass(prompt="Password : ", stream=sys.stderr)

        if self.email and self.password and self.course_url:
            try:

                print("Trying to Login ...")

                if "stackskills" in self.course_url:

                    login_url = "https://sso.teachable.com/secure/1453/users/sign_in?flow_school_id=1453"

                elif "infosec4tc" in self.course_url:

                    login_url = "https://sso.teachable.com/secure/100167/users/sign_in?flow_school_id=100167"

                elif "ehacking" in self.course_url:

                    login_url = "https://sso.teachable.com/secure/13898/users/sign_in?flow_school_id=13898"

                elif "designerup" in self.course_url:
                    login_url = "https://sso.teachable.com/secure/278741/users/sign_in?flow_school_id=278741"

                elif "codewithmosh" in self.course_url:
                    login_url = "https://sso.teachable.com/secure/146684/users/sign_in?flow_school_id=146684"




                else:
                    print("[-] Invalid course URL.")
                    self.login()

                scraper = cloudscraper.create_scraper(sess=s, delay=20)

                try:
                    login = scraper.get(login_url).content

                    login_html = lxml.html.fromstring(login)

                    hidden_inputs = login_html.xpath(r'//form//input[@type="hidden"]')

                    form = {x.attrib["name"]: x.attrib["value"] for x in hidden_inputs}

                    form['user[email]'] = self.email
                    form['user[password]'] = self.password

                    response = s.post(login_url, data=form)

                    if "Invalid email or password" in response.text:

                        print("[-] Login failed.Invalid username or password.")

                        self.login()

                    else:
                        print("[+] Login successful.")

                        self.getSectionAndLinks(self.course_url)

                except requests.ConnectionError as ex:
                    print("[-] Error : Connection failed . Check your internet connection and try again!")
                    sys.exit(1)

                except Exception as ex:
                    print(ex)

                    if self._cookie is None:
                        try:
                            self._cookie = raw_input("Enter cookie instead : ")
                        except:
                            self._cookie = input("Enter cookie instead: ")

                    self.getSectionAndLinks(self.course_url)

            except Exception as ex:

                print("[-] Error : " + str(ex))
                # traceback.print_exc(file=sys.stdout)

                sys.exit(1)

        else:

            print("[-] Please enter course url , email and password")
            self.login()

    def getSectionAndLinks(self, url):
        self.url = url

        if 'com' in self.url:
            index = url.index('com') + 3

        elif '.co' in self.url:
            index = url.index('.co') + 3
        else:
            index = url.index('net') + 3

        self.domain = self.url[0:index]

        try:

            print("Downloading to :" + self.parentFolder)
            print("Collecting course information ...")

            if 'designerup.co' in self.url:
                data = s.get(self.url)

                soup = BeautifulSoup(data.text, 'html.parser')
                courseName = soup.find('div', attrs={'class': 'course-info'}).find('h4')

            else:
                data = requests.get(self.url)
                soup = BeautifulSoup(data.text, 'html.parser')

                # courseName = soup.find('h2', attrs={'class': 'row'})

                courseName = soup.find('h1', attrs={'class': 'course-title'})

                if courseName is None:
                    courseName = soup.find('h1', attrs={'class': 'm-0'})

                if courseName is None:
                    courseName = soup.find('div', attrs={'class': 'bannerHeader'}).find('h2')

                if courseName is None:
                    print("Failed to get course Name")

            courseName = str(courseName.get_text()).strip()

            print("\nCourse name : " + (str(courseName)))

            self.initialize()
            os.chdir(self.parentFolder)

            try:
                if os.path.exists(courseName):
                    os.chdir(courseName)
                else:
                    os.mkdir(courseName)
                    os.chdir(courseName)

            except Exception as e:
                self.createAndChangeDir(courseName)

                # os.chdir(courseName)

            if self._cookie is not None:
                print("Trying cookie authentication ...")
                cookie = self._cookie.strip()

                s.cookies.set('_session_id', cookie, path='/', domain=self.domain[8:])
                data = s.get(self.url)

                x = data.cookies.iteritems()

                for y in x:

                    signed_in = ('signed_in', 'true')

                    if signed_in == y:
                        print("[+] Cookie authentication succeeded")
                        break

                else:
                    print("[-] Cookie authentication failed!")
                    return False


            else:
                data = s.get(self.url)

            print("Getting course sections ...")
            soup = BeautifulSoup(data.text, 'html.parser')

            try:

                courseImage = soup.find('div', {'class': 'course-image'}).find('img').get('src')

                print("Downloading course image ... ")

                wget.download(str(courseImage))

            except Exception as e:
                try:
                    courseImage = soup.find('img', {'class': 'course-image'}).get('src')

                    print("Downloading course image ... ")

                    wget.download(str(courseImage))

                except Exception as ex:
                    pass

            # os.rename(filesrc, str(self.name))

            c = 1
            for i in soup.find_all('span', {'class': 'section-lock'}):
                section = i.next_sibling.strip()
                folder = str(c) + "." + str(section).strip()

                try:
                    if os.path.exists(folder):
                        os.chdir(folder)
                    else:
                        os.mkdir(folder)
                        os.chdir(folder)

                except Exception as e:
                    self.createAndChangeDir(folder)

                print("\n[+] Found Section : ", section + "\n")

                divs = soup.find_all('div', {'class': 'course-section'}, )

                for div in divs:
                    links = []

                    if div.find(text=re.compile(section)):

                        theDiv = div

                        soupLinks = BeautifulSoup(str(theDiv), 'html.parser')

                        for i in soupLinks.find_all('a', {'class': 'item'}):
                            links.append(self.domain + i.attrs['href'])

                        self.prepareDownload(links)

                        links = []

                        os.chdir(os.path.join(self.parentFolder, courseName))

                        break

                c += 1

            # self.sanitizeFileNames()
            print(
                "\n[+] Download completed. Enjoy your course " + self.email + "\n\nSupport future development by donating https://www.buymeacoffee.com/barakagb\n\n")

        except Exception as ex:
            print("[-] Error : " + str(ex))
            sys.exit(1)

    def initialize(self):

        def isValid(data):
            from uuid import getnode as get_cid
            import hashlib
            cid = str(get_cid())

            try:
                cid = cid.encode("utf-8")

            except Exception as e:
                print("An error occured . Please report this issue")
                sys.exit(1)

            cid = hashlib.sha256(cid).hexdigest()
            self.data = data
            data = {"from": "gb-dl",
                    "key": self.data,
                    "machine_id": cid}
            data_json = json.dumps(data)
            headers = {'Content-type': 'application/json'}
            url = "https://baraka.heliohost.org/gb-dl/webhook.php"
            response = requests.post(url, data=data_json, headers=headers)

            response_json = json.loads(response.content)

            if response_json['response'] == "200":
                try:
                    os.chdir(self.parentFolder)
                    with open("licensefile.skm", 'w') as file:

                        file.write(data['key'].strip())
                        pass
                except Exception as e:

                    pass
            else:

                print(response_json['message'])
                print("Kindly contribute a one time donation and get a key to use this tool. Thanks\n"
                      "Get your key here https://bmc.xyz/l/gbdl")
                sys.exit(1)

        try:
            homeFolder = os.path.expanduser('~')

            with open(os.path.join(homeFolder, 'licensefile.skm'), 'r') as file:
                license_key = file.readline().strip()

                if license_key == "":
                    try:
                        license_key = raw_input("Enter your gb-dl license key :").strip()
                    except Exception as e:

                        license_key = input("Enter your gb-dl license key :").strip()
                    isValid(license_key)
                else:

                    isValid(license_key)

        except Exception as e:

            with open(os.path.join(homeFolder, 'licensefile.skm'), 'w') as _file:
                _file.write("")
                self.initialize()

    def prepareDownload(self, links):

        c = 1
        totalLectures = len(links)

        Attachments = []

        for link in links:
            print("Preparing  lecture " + str(c) + " of " + str(totalLectures) + " download ... ")

            data2 = s.get(link)
            soup1 = BeautifulSoup(data2.text, 'html.parser')

            # wistia= soup1.findAll("div", id=lambda x: x and x.startswith('wistia-'))

            _dict = {}
            for i in soup1.find_all('a', {'class': 'download'}):
                _dict["href"] = i.attrs['href']
                _dict["name"] = i.attrs['data-x-origin-download-name']
                Attachments.append(_dict)

            for attachment in soup1.findAll('iframe'):
                Attachments.append(attachment.get('src'))

            for i in soup1.findAll('div', {"class": 'attachment-wistia-player'}):
                wistia_id = (i.get('data-wistia-id'))

                self.download(wistia_id)

            self.download(0, Attachments)

            Attachments = []

            c += 1

    def download(self, id, *attachments):

        if id != 0:
            self.wistia_url = "http://fast.wistia.net/embed/iframe/"
            course_url = self.wistia_url + id

            try:
                print("Starting download ... ")
                ydl_opts = {}
                with youtube_dl.YoutubeDL(ydl_opts) as ydl:
                    ydl.download([course_url])

            except Exception as ex:
                print("[-]" + "Error : " + str(ex))
        else:

            for attachment in attachments:
                try:

                    if attachment:
                        for x in attachment:
                            self.name = str(x["name"])
                            self.url = str((x["href"]).strip('[]'))
                        # self.url = self.url[2:-1].strip()

                        print("Downloading attachment : " + self.name)
                        filesrc = wget.download(str(self.url))

                        os.rename(filesrc, str(self.name))

                except Exception as ex:

                    print("[-]" + "Error can not download attachment  : " + str(ex))

    def sanitizeFileNames(self):

        if "stackskills" in self.course_url:
            return

        print("sanitizing file names ...")

        path = os.getcwd()
        for root, dirs, files in os.walk(path):

            for dir in dirs:
                subFolder = os.path.join(path, dir)
                # print subFolder, "\n"

                for root, dirs, files in os.walk(subFolder):
                    for file in files:
                        try:
                            index = file.index('mp4') + 3

                            filesrc = os.path.join(subFolder, file)
                            filedest = os.path.join(subFolder, file[0:index])

                            os.rename(filesrc, filedest)
                        except Exception as e:
                            pass
        print("[+]" + "file name sanitation completed")

    def createAndChangeDir(self, dirName):
        ''' Creates and changes directory if dir name has invalid chars '''

        invalidChars = ['<', '>', ':', '"', '/', '|', '\\', '?', '*']
        for char in invalidChars:
            if char in dirName:
                dirName = dirName.replace(char, "")
                if os.path.exists(dirName):
                    os.chdir(dirName)

                else:
                    os.mkdir(dirName)
                    os.chdir(dirName)
        return

    def main(self):

        banner = '''  

                   _____ ____                 _ _ 
                  / ____|  _ \               | | |
                 | |  __| |_) |  ______    __| | |
                 | | |_ |  _ <  |______|  / _` | |
                 | |__| | |_) |          | (_| | |
                  \_____|____/            \__,_|_|

           			        Version : 1.6.3.1
                            Author  : BarakaGB
                            Visit   : https://github.com/barakagb/gb-dl
                            Donation: https://www.buymeacoffee.com/barakagb
                            Key url : https://bmc.xyz/l/gbdl
                    '''
        print(banner)
        print(
            '''    A python based utility to download courses from infosec4tc.teachable.com ,
    ehacking.net ,stackskills.com and designerup.co ...etc for personal offline 
    use.
     \n\n''')
        print('''    Usage: gb-dl.py [-h]   \n\n     ''')
        parser = argparse.ArgumentParser()
        parser.add_argument('-f', '--file', type=str,
                            help="Load course url from a txt file for multiple course urls (separated by new line)",
                            metavar='')

        args = parser.parse_args()
        if args.file:
            print("Getting course url(s) from file ...")
            course_urls = []

            with open(args.file, "r") as file:
                course_urls = file.readlines()

            try:
                self.email = raw_input("Email : ")
                prompt_txt = "Password :"
                self.password = getpass.getpass(prompt=prompt_txt, stream=sys.stderr)

            except TypeError as e:
                prompt_txt = "Password :"
                prompt_txt = prompt_txt.encode("utf-8")
                self.password = getpass.getpass(prompt=prompt_txt, stream=sys.stderr)

            except Exception as e:

                self.email = input("Email : ")
                self.password = getpass.getpass(prompt="Password : ", stream=sys.stderr)

            print("Found  " + str(len(course_urls)) + " course(s) from file.")

            for url in course_urls:
                print("Downloading " + str(url) + " ...")
                self.login(course_url=url, email=self.email, password=self.password)



        else:
            self.login()


if __name__ == '__main__':

    try:
        DL = DL()

    except KeyboardInterrupt:
        print("User Interrupted. ")
        sys.exit(1)

    except:
        sys.exit(1)
